##############################################################################
#
#  Palm-FE Palm Pilot Functional Emulator
#  (c) Vladi Belperchinov-Shabanski "Cade" 2000-2001 
#  <cade@biscom.net> <cade@datamax.bg>
#
#  DISTRIBUTED UNDER GPL LICENSE, SEE `COPYING' FILE FOR DETAILS
#
##############################################################################
package p3_mod_address;
use p3_ses;
use p3_conf;
use p3_uti;
use Exporter;
@ISA    = qw( Exporter );
@EXPORT = qw( main );
use strict;

our %OPT = ( 
             cats => 1,                  # this modules uses categories
           );

sub main
{
  my    $act = $SDA{ "in_act" };
  if    ( $act eq "form" )   { form_item()   }
  elsif ( $act eq "update" ) { update_item() }
  elsif ( $act eq "delete" ) { delete_item() }
  elsif ( $act eq "view" )   { view_item()   }
  else  { list_items() }
};

##############################################################################

sub form_item
{
  my $text;
  
  my $id = $SDA{ "in_id" };
  
  my %data = ();
  
  load_hash( $id, \%data );

  my @td;

  my $cats_list = get_cats_option_list( $data{ category } );

  push @td, [ "<b>Name:", 
              "<input name=name value='$data{name}' size=40>" ];
  push @td, [ "<b>Position:",
              "<input name=position value='$data{position}' size=40>" ];            
  push @td, [ "<b>Company:",
              "<input name=company value='$data{company}' size=40>" ];
  push @td, [ "<b>Work telephone#:",
              "<input name=work value='$data{work}' size=40>" ];
  push @td, [ "<b>Home telephone#:",
              "<input name=home value='$data{home}' size=40>" ];
  push @td, [ "<b>FAX #:",
              "<input name=fax value='$data{fax}' size=40>" ];            
  push @td, [ "<b>Other/Mobile telephone#:",
              "<input name=other value='$data{other}' size=40>" ];
  push @td, [ "<b>E-Mail address:",
              "<input name=email value='$data{email}' size=40>" ];
  push @td, [ "<b>Address:",
              "<textarea name=address rows=6 cols=40>$data{address}</textarea>" ];            
  push @td, [ "<b>Category:", 
              "<b><select name=category>$cats_list</select>" ];
  push @td, [ "<b>Notes:",
              "<textarea name=note rows=6 cols=40>$data{note}</textarea>" ];
  
  my $cancel = $id == 0 ? "act=list" : "act=view&id=$id";
  $text .= "
    <center>
    <form action=$SCR?>
    <input type=hidden name=id   value=$id>
    <input type=hidden name=act  value=update>"
    . fmt_table2( @td, { width => "80%", 
                         right1 => "hack",
                         cellpadding => 1 } ) .
    "
    <hr noshade size=1 width=80%>
    <-subimg:done>
    <a href='$SCR?$cancel'><-img:cancel></a>
    <a href='$SCR?act=delete&id=$id'><-img:delete></a>
    </form>
    ";

  return $text;
};

##############################################################################

sub update_item
{
  my $id = $SDA{ "in_id" };
  $id = new_id() if $id == 0;

  my %data;
  for( qw( name position company work home fax other email address category note ) )
    {
    $data{ $_ } = $SDA{ "in_$_" };
    }
  $data{ "name" } ||= '[unnamed]';
  $data{ "find_title" } = $data{ name }; # see find module notes!
  save_hash( $id, \%data );

  $SDA{ "in_id" } = $id;
  return view_item();
};

##############################################################################

sub delete_item
{
  my $id = $SDA{ "in_id" };
  system( "mv $id deleted/$id" );
  return list_items();
};

##############################################################################

sub list_items
{
  my $text;

  my @td;
  push @td, [ "+<b>Name", "<b>Category", "<b>Work#", "<b>Home#" ];
  
  for( load_dir( ".", "[0-9].*" ) )
    {
    my $id = $_;
    my %data;
    load_hash( $id, \%data );

    if ( $CAT ne "All" )
      {
      if ( $data{ category } ne $CAT ) { next };
      }
    my $note_reminder = rtf_note_reminder( $data{note} );
    
    my $mail_str;
    for( split /\s+/, $data{email} )
      { $mail_str .= "<a href='mailto:$_'><-img:mail2></a>"; }

    my $cat_e = CGI::escape( $data{ category } );
    my $cat_link = "&nbsp;&nbsp;<font size=-1>(<a href=$SCR?act=list&cat=$cat_e>$data{ category }</a>)</font>";

    my $name = $data{name} || '[unnamed]';
    
    my $co_str = "&nbsp;/ <b>$data{company}</b>" if $data{company};
    push @td, [ "<a href=$SCR?act=view&id=$id><b>$name</b></a> $mail_str
                 $co_str<font size=-1>$note_reminder</font>",
                 $cat_link,
                "<b>$data{work}", 
                "<b>$data{home}" ];
    }

  $text .= fmt_table( @td ) . "
    <p>
    <hr noshade size=1 width=80%>
    <center>
    <a href=$SCR?act=form&id=0><-img:new></a>
    </center>
  ";

  return $text;
};

##############################################################################

sub view_item
{
  my $text;
  
  my $id = $SDA{ "in_id" };
  
  my %data;
  load_hash( $id, \%data );

  my $notes = rtf_text( $data{note} );

  my $mail_str;
  for( split /\s+/, $data{email} )
    { $mail_str .= "<a href='mailto:$_'>$_</a> "; }

  my @td;
  
  push @td, [ "=<b>Category: $data{category}" ];
  push @td, [ "<b>Name:",
              "+<b>$data{name}" ];
  push @td, [ "<b>Position:",
              "<b>$data{position}" ];
  push @td, [ "<b>Company:",
              "<b>$data{company}" ];
  push @td, [ "<b>Work telephone:",
              "<b>$data{work}" ];
  push @td, [ "<b>Home telephone:",
              "<b>$data{home}" ];
  push @td, [ "<b>Fax number:",
              "<b>$data{fax}" ];
  push @td, [ "<b>Other/Mobile telephone:",
              "<b>$data{other}" ];
  push @td, [ "<b>E-Mail address:",
              "<b>$mail_str" ];
  push @td, [ "<b>Address:",
              "<b>$data{address}" ];
  push @td, [ "<b>Notes:",
              "<pre>$notes" ];

  $text .= "
    <center>"
    . fmt_table( @td, { width => "80%", right1 => "hack" } ) .
    "
    <hr noshade size=1 width=80%>
    <a href='$SCR?act=list'><-img:ok></a>
    <a href='$SCR?act=form&id=$id'><-img:edit></a>
    ";
  
  return $text;
};



1;
